stages:
  - docker-build
  - package
  - test-core
  - validate-api
  - docker-deploy
  - docs

include:
  - project: 'nirvati/ci'
    file: '/docker-legacy.yml'
    inputs:
      username: $HARBOR_USERNAME
      password: $HARBOR_PASSWORD
      registry: $HARBOR_HOST
      project: $HARBOR_PROJECT
      container: $CI_PROJECT_NAME
      buildx-args: --file docker/prod/Dockerfile

package-debian:
  stage: package
  image: debian:bookworm
  allow_failure: true
  script:
    - apt update && apt install -y ruby-rubygems
    - gem install pkgr
    - pkgr package . --name=nepenthes

test-core:
  stage: test-core
  image: docker:latest
  allow_failure: true
  services:
    - docker:dind
  script:
    - docker compose -f docker-compose.ci.yml build --pull ci
    - docker compose -f docker-compose.ci.yml run ci setup-tests run-units run-features
    - docker compose -f docker-compose.ci.yml down --remove-orphans -t 10

validate-api:
  stage: validate-api
  image: ruby:3.2
  script:
    - curl -v https://install-node.vercel.app/ | bash -s -- 16.17 --yes
    - ./script/api/validate_spec

pages:
  stage: docs
  cache:
    paths:
      - docs/node_modules/
  image: node:18
  script:
    - rm ../public -rf
    - corepack enable
    - cd docs
    - pnpm install
    - pnpm run docs:build
  artifacts:
    paths:
      - public
  only:
    - dev
